//: c08:Callbacks.java
// Using inner classes for callbacks

interface Incrementable {
  void increment();
}

class Callee {
  private int i = 0;
  private void incr() { 
    i++;
    System.out.println(i);
  }
  private class Closure implements Incrementable {
    public void increment() { incr(); }
  }
  Incrementable getCallbackHandle() {
    return new Closure();
  }
}

class Caller {
  private Incrementable callbackHandle;
  Caller(Incrementable cbh) {
    callbackHandle = cbh;
  }
  void go() {
    callbackHandle.increment();
  }
}

public class Callbacks {
  public static void main(String[] args) {
    Callee c = new Callee();
    Caller cc = new Caller(c.getCallbackHandle());
    cc.go();
    cc.go();
  }
} ///:~