//: c14:Counter4.java
// By separating your thread from the main class,
// you can have as many threads as you want. 
// <applet code=Counter4 width=600 height=600>
// <param name=size value="20"></applet>
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import com.bruceeckel.swing.*;

class Ticker extends Thread {
  private JButton b = new JButton("Toggle");
  private JTextField t = new JTextField(10);
  private int count = 0;
  private boolean runFlag = true;
  public Ticker(Container c) {
    b.addActionListener(new ToggleL());
    JPanel p = new JPanel();
    p.add(t);
    p.add(b);
    c.add(p);
  }
  class ToggleL implements ActionListener {
    public void actionPerformed(ActionEvent e) {
      runFlag = !runFlag;
    }
  }
  public void run() {
    while (true) {
      if (runFlag)
        t.setText(Integer.toString(count++));
      try {
        sleep(100);
      } catch (InterruptedException e) {}
    }
  }
}
 
public class Counter4 extends JApplet {
  private JButton start = new JButton("Start");
  private boolean started = false;
  private Ticker[] s;
  private boolean isApplet = true;
  private int size;
  public void init() {
    Container cp = getContentPane();
    cp.setLayout(new FlowLayout());
    // Get parameter "size" from Web page:
    if (isApplet)
      size = 
        Integer.parseInt(getParameter("size"));
    s = new Ticker[size];
    for (int i = 0; i < s.length; i++)
      s[i] = new Ticker(cp);
    start.addActionListener(new StartL());
    cp.add(start);
  }
  class StartL implements ActionListener {
    public void actionPerformed(ActionEvent e) {
      if(!started) {
        started = true;
        for (int i = 0; i < s.length; i++)
          s[i].start();
      }
    }
  }
  public static void main(String[] args) {
    Counter4 applet = new Counter4();
    // This isn't an applet, so set the flag and
    // produce the parameter values from args:
    applet.isApplet = false;
    applet.size =
      (args.length == 0 ? 5 :
        Integer.parseInt(args[0]));
    JFrame frame = new JFrame("Counter4");
//#frame.setDefaultCloseOperation(EXIT_ON_CLOSE);
    frame.addWindowListener(new WClose()); // 1.2
    frame.getContentPane().add(applet);
    frame.setSize(200, applet.size * 50);
    applet.init();
    applet.start();
    frame.setVisible(true);
  }
} ///:~