//: c16:StateDemo.java
// Simple demonstration of the State pattern.

interface StateBase {
  void f();
  void g();
  void h();
  void changeImp(StateBase newImp);
}

class State implements StateBase {
  private StateBase implementation;
  public State(StateBase imp) { 
    implementation = imp; 
  }
  public void changeImp(StateBase newImp) {
    implementation = newImp;
  }
  // Pass method calls to the implementation:
  public void f() { implementation.f(); }
  public void g() { implementation.g(); }
  public void h() { implementation.h(); }
}

class Implementation1 implements StateBase {
  public void f() { 
    System.out.println("Implementation1.f()"); 
  }
  public void g() { 
    System.out.println("Implementation1.g()"); 
  }
  public void h() { 
    System.out.println("Implementation1.h()"); 
  }
  public void changeImp(StateBase newImp) {}
}

class Implementation2 implements StateBase {
  public void f() { 
    System.out.println("Implementation2.f()"); 
  }
  public void g() { 
    System.out.println("Implementation2.g()"); 
  }
  public void h() { 
    System.out.println("Implementation2.h()"); 
  }
  public void changeImp(StateBase newImp) {}
}

public class StateDemo {
  static void test(StateBase b) {
    b.f();
    b.g();
    b.h();
  }
  public static void main(String args[]) {
    StateBase b = 
      new State(new Implementation1());
    test(b);
    b.changeImp(new Implementation2());
    test(b);
  }
} ///:~